/*
 * Copyright 2020 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.dashbuilder.displayer.client.widgets;

import com.google.gwtmockito.GwtMockitoTestRunner;
import org.dashbuilder.displayer.client.component.ExternalComponentDispatcher;
import org.dashbuilder.displayer.client.widgets.ExternalComponentPresenter.View;
import org.dashbuilder.displayer.external.ExternalComponentMessage;
import org.dashbuilder.displayer.external.ExternalComponentMessageHelper;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;

import static org.mockito.ArgumentMatchers.eq;
import static org.mockito.Mockito.verify;

@RunWith(GwtMockitoTestRunner.class)
public class ExternalComponentPresenterTest {

    @Mock
    View view;

    @Mock
    ExternalComponentDispatcher dispatcher;

    @Mock
    ExternalComponentMessageHelper messageHelper;

    @InjectMocks
    ExternalComponentPresenter externalComponentPresenter;

    @Test
    public void testSendMessage() {
        ExternalComponentMessage message = new ExternalComponentMessage();

        externalComponentPresenter.sendMessage(message);

        verify(messageHelper).withId(eq(message), eq(externalComponentPresenter.getId()));
        verify(view).postMessage(eq(message));
    }

}